Index: /trunk/src/sys/arch/mips/mips/db_interface.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/db_interface.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/db_interface.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: db_interface.c,v 1.64.16.16 2010/02/01 04:16:19 matt Exp $	*/
+/*	db_interface.c,v 1.64.16.22 2011/04/29 08:26:24 matt Exp	*/
 
 /*
@@ -28,6 +28,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: db_interface.c,v 1.64.16.16 2010/02/01 04:16:19 matt Exp $");
-
+__KERNEL_RCSID(0, "db_interface.c,v 1.64.16.22 2011/04/29 08:26:24 matt Exp");
+
+#include "opt_multiprocessor.h"
 #include "opt_cputype.h"	/* which mips CPUs do we support? */
 #include "opt_ddb.h"
@@ -38,9 +39,12 @@
 #include <sys/param.h>
 #include <sys/proc.h>
-#include <sys/user.h>
 #include <sys/reboot.h>
+#include <sys/atomic.h>
+#include <sys/cpu.h>
 
 #include <uvm/uvm_extern.h>
 
+#include <mips/asm.h>
+#include <mips/regnum.h>
 #include <mips/cache.h>
 #include <machine/pte.h>
@@ -60,25 +64,33 @@
 #include <ddb/db_interface.h>
 #include <ddb/db_lex.h>
-#endif
+#include <ddb/db_run.h>	/* for db_continue_cmd() proto */
+#endif
+
+#define NOCPU   ~0
+volatile u_int ddb_cpu = NOCPU;
 
 int		db_active = 0;
 db_regs_t	ddb_regs;
+
+#if (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+static void db_watch_cmd(db_expr_t, bool, db_expr_t, const char *);
+static void db_unwatch_cmd(db_expr_t, bool, db_expr_t, const char *);
+#endif	/* (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0 */
+
+#ifdef MULTIPROCESSOR
+static void db_mach_cpu(db_expr_t, bool, db_expr_t, const char *);
+#endif
 
 void db_tlbdump_cmd(db_expr_t, bool, db_expr_t, const char *);
 void db_kvtophys_cmd(db_expr_t, bool, db_expr_t, const char *);
 void db_cp0dump_cmd(db_expr_t, bool, db_expr_t, const char *);
-#ifdef MIPS64_XLS
+#if defined(MIPS64_RMIXL) || defined(MIPS64R2_RMIXL)
 void db_mfcr_cmd(db_expr_t, bool, db_expr_t, const char *);
 void db_mtcr_cmd(db_expr_t, bool, db_expr_t, const char *);
 #endif
 
-static void	kdbpoke_4(vaddr_t addr, int newval);
-static void	kdbpoke_2(vaddr_t addr, short newval);
-static void	kdbpoke_1(vaddr_t addr, char newval);
-static short	kdbpeek_2(vaddr_t addr);
-static char	kdbpeek_1(vaddr_t addr);
-vaddr_t		MachEmulateBranch(struct trapframe *, vaddr_t, unsigned, int);
-
 paddr_t kvtophys(vaddr_t);
+
+CTASSERT(sizeof(ddb_regs) == sizeof(struct reg));
 
 #ifdef DDB_TRACE
@@ -93,73 +105,20 @@
 #endif
 
-static short
-kdbpeek_2(vaddr_t addr)
-{
-
-	return *(short *)addr;
-}
-
-static char
-kdbpeek_1(vaddr_t addr)
-{
-
-	return *(char *)addr;
-}
-
-/*
- * kdbpoke -- write a value to a kernel virtual address.
- *    XXX should handle KSEG2 addresses and check for unmapped pages.
- *    XXX user-space addresess?
- */
-static void
-kdbpoke_4(vaddr_t addr, int newval)
-{
-
-	*(int*) addr = newval;
-	wbflush();
-}
-
-static void
-kdbpoke_2(vaddr_t addr, short newval)
-{
-
-	*(short*) addr = newval;
-	wbflush();
-}
-
-static void
-kdbpoke_1(vaddr_t addr, char newval)
-{
-	*(char*) addr = newval;
-	wbflush();
-}
-
-#if 0 /* UNUSED */
-/*
- * Received keyboard interrupt sequence.
- */
-void
-kdb_kbd_trap(int *tf)
-{
-
-	if (db_active == 0 && (boothowto & RB_KDB)) {
-		printf("\n\nkernel: keyboard interrupt\n");
-		ddb_trap(-1, tf);
-	}
-}
-#endif
-
 #ifndef KGDB
 int
 kdb_trap(int type, struct reg *regs)
 {
-
-#ifdef notyet
+	int s;
+
 	switch (type) {
+	case T_WATCH:		/* watchpoint */
 	case T_BREAK:		/* breakpoint */
+		printf("kernel: %s trap\n", trap_names[type & 0x1f]);
+		break;
 	case -1:		/* keyboard interrupt */
+		printf("kernel: kdbint trap\n");
 		break;
 	default:
-		printf("kernel: %s trap", trap_type[type & 0xff]);
+		printf("kernel: %s trap\n", trap_names[type & 0x1f]);
 		if (db_recover != 0) {
 			db_error("Faulted in DDB; continuing...\n");
@@ -168,8 +127,26 @@
 		break;
 	}
-#endif
-	/* Should switch to kdb`s own stack here. */
+
+	s = splhigh();
+
+#ifdef MULTIPROCESSOR
+	bool first_in_ddb = false;
+	const u_int cpu_me = cpu_number();
+	const u_int old_ddb_cpu = atomic_cas_uint(&ddb_cpu, NOCPU, cpu_me);
+	if (old_ddb_cpu == NOCPU) {
+		first_in_ddb = true;
+		cpu_pause_others();
+	} else {
+		if (old_ddb_cpu != cpu_me) {
+			KASSERT(cpu_is_paused(cpu_me));
+			cpu_pause(regs);
+			splx(s);
+			return 1;
+		}
+	}
+	KASSERT(! cpu_is_paused(cpu_me));
+#endif
+
 	ddb_regs = *regs;
-
 	db_active++;
 	cnpollc(1);
@@ -177,8 +154,18 @@
 	cnpollc(0);
 	db_active--;
-
 	*regs = ddb_regs;
 
-	return (1);
+#ifdef MULTIPROCESSOR
+	if (atomic_cas_uint(&ddb_cpu, cpu_me, NOCPU) == cpu_me) {
+		cpu_resume_others();
+	} else {
+		cpu_resume(ddb_cpu);
+		if (first_in_ddb)
+			cpu_pause(regs);
+	}
+#endif
+
+	splx(s);
+	return 1;
 }
 
@@ -197,13 +184,8 @@
 db_read_bytes(vaddr_t addr, size_t size, char *data)
 {
-	int *ip;
-	short *sp;
-
-	while (size >= 4)
-		ip = (int*)data, *ip = kdbpeek(addr), data += 4, addr += 4, size -= 4;
-	while (size >= 2)
-		sp = (short *)data, *sp = kdbpeek_2(addr), data += 2, addr += 2, size -= 2;
-	if (size == 1)
-		*data = kdbpeek_1(addr);
+	const char *src = (char *)addr;
+
+	while (size--)
+		*data++ = *src++;
 }
 
@@ -214,29 +196,12 @@
 db_write_bytes(vaddr_t addr, size_t size, const char *data)
 {
-	vaddr_t p = addr;
+	char *p = (char *)addr;
 	size_t n = size;
 
-#ifdef DEBUG_DDB
-	printf("db_write_bytes(%lx, %d, %p, val %x)\n", addr, size, data,
-	       	(addr &3 ) == 0? *(u_int*)addr: -1);
-#endif
-
-	while (n >= 4) {
-		kdbpoke_4(p, *(const int *)data);
-		p += 4;
-		data += 4;
-		n -= 4;
-	}
-	if (n >= 2) {
-		kdbpoke_2(p, *(const short *)data);
-		p += 2;
-		data += 2;
-		n -= 2;
-	}
-	if (n == 1) {
-		kdbpoke_1(p, *(const char *)data);
-	}
-
-	mips_icache_sync_range((vaddr_t) addr, size);
+	while (n--)
+		*p++ = *data++;
+
+	wbflush();
+	mips_icache_sync_range(addr, size);
 }
 
@@ -254,5 +219,5 @@
 
 		for (i = 0; i < mips_options.mips_num_tlb_entries; i++) {
-			mips1_tlb_read_indexed(i, &tlb);
+			tlb_read_indexed(i, &tlb);
 			db_printf("TLB%c%2d Hi 0x%08x Lo 0x%08x",
 				(tlb.tlb_lo1 & MIPS1_PG_V) ? ' ' : '*',
@@ -311,23 +276,15 @@
 
 #define	FLDWIDTH	10
-#define	SHOW32(reg, name)						\
+
+#define SHOW32(reg, name)	SHOW32SEL(reg, 0, name)
+#define SHOW64(reg, name)	SHOW64SEL(reg, 0, name)
+
+#define	SHOW32SEL(num, sel, name)					\
 do {									\
 	uint32_t __val;							\
 									\
-	__asm volatile("mfc0 %0,$" ___STRING(reg) : "=r"(__val));	\
-	printf("  %s:%*s %#x\n", name, FLDWIDTH - (int) strlen(name),	\
-	    "", __val);							\
-} while (0)
-
-#define SHOW64(reg, name)	MIPS64_SHOW64(reg, 0, name)
-
-#define	MIPS64_SHOW32(num, sel, name)					\
-do {									\
-	uint32_t __val;							\
-									\
-	KASSERT (CPUIS64BITS);						\
 	__asm volatile(							\
 		".set push			\n\t"			\
-		".set mips64			\n\t"			\
+		".set mips32			\n\t"			\
 		"mfc0 %0,$%1,%2			\n\t"			\
 		".set pop			\n\t"			\
@@ -338,5 +295,5 @@
 
 /* XXX not 64-bit ABI safe! */
-#define	MIPS64_SHOW64(num, sel, name)					\
+#define	SHOW64SEL(num, sel, name)					\
 do {									\
 	uint64_t __val;							\
@@ -354,4 +311,46 @@
 } while (0)
 
+#define	SET32(reg, name, val)						\
+do {									\
+									\
+	__asm volatile("mtc0 %0,$" ___STRING(reg) :: "r"(val));		\
+	if (name != NULL)						\
+		printf("  %s =%*s %#x\n", name,				\
+		    FLDWIDTH - (int) strlen(name), "", val);		\
+} while (0)
+
+#define SET64(reg, name)	MIPS64_SET64(reg, 0, name)
+
+#define	MIPS64_SET32(num, sel, name, val)				\
+do {									\
+									\
+	__asm volatile(							\
+		".set push			\n\t"			\
+		".set mips32			\n\t"			\
+		"mtc0 %0,$%1,%2			\n\t"			\
+		".set pop			\n\t"			\
+	    :: "r"(val), "n"(num), "n"(sel));				\
+	if (name != NULL)						\
+		printf("  %s =%*s %#x\n", name,				\
+		    FLDWIDTH - (int) strlen(name), "", val);		\
+} while (0)
+
+/* XXX not 64-bit ABI safe! */
+#define	MIPS64_SET64(num, sel, name, val)				\
+do {									\
+									\
+	KASSERT (CPUIS64BITS);						\
+	__asm volatile(							\
+		".set push 			\n\t"			\
+		".set mips64			\n\t"			\
+		".set noat			\n\t"			\
+		"dmtc0 %0,$%1,%2		\n\t"			\
+		".set pop"						\
+	    :: "r"(val), "n"(num), "n"(sel));				\
+	if (name != NULL)						\
+		printf("  %s =%*s %#"PRIx64"\n", name,			\
+		    FLDWIDTH - (int) strlen(name), "", (uint64_t)val);	\
+} while (0)
+
 void
 db_cp0dump_cmd(db_expr_t addr, bool have_addr, db_expr_t count,
@@ -396,8 +395,10 @@
 	}
 
-	if ((cp0flags & MIPS_CP0FL_EIRR) != 0)
-		MIPS64_SHOW64(9, 6, "eirr");
-	if ((cp0flags & MIPS_CP0FL_EIMR) != 0)
-		MIPS64_SHOW64(9, 7, "eimr");
+	if ((cp0flags & MIPS_CP0FL_USE) != 0) {
+		if ((cp0flags & MIPS_CP0FL_EIRR) != 0)
+			SHOW64SEL(9, 6, "eirr");
+		if ((cp0flags & MIPS_CP0FL_EIMR) != 0)
+			SHOW64SEL(9, 7, "eimr");
+	}
 
 	if (CPUIS64BITS) {
@@ -424,26 +425,28 @@
 	if ((cp0flags & MIPS_CP0FL_USE) != 0) {
 		if ((cp0flags & MIPS_CP0FL_EBASE) != 0)
-			MIPS64_SHOW32(15, 1, "ebase");
+			SHOW32SEL(15, 1, "ebase");
 		if ((cp0flags & MIPS_CP0FL_CONFIG) != 0)
 			SHOW32(MIPS_COP_0_CONFIG, "config");
-		if ((cp0flags & MIPS_CP0FL_CONFIGn(0)) != 0)
-			MIPS64_SHOW32(16, 0, "config0");
-		if ((cp0flags & MIPS_CP0FL_CONFIGn(1)) != 0)
-			MIPS64_SHOW32(16, 1, "config1");
-		if ((cp0flags & MIPS_CP0FL_CONFIGn(2)) != 0)
-			MIPS64_SHOW32(16, 2, "config2");
-		if ((cp0flags & MIPS_CP0FL_CONFIGn(3)) != 0)
-			MIPS64_SHOW32(16, 3, "config3");
-		if ((cp0flags & MIPS_CP0FL_CONFIGn(4)) != 0)
-			MIPS64_SHOW32(16, 4, "config4");
-		if ((cp0flags & MIPS_CP0FL_CONFIGn(5)) != 0)
-			MIPS64_SHOW32(16, 5, "config5");
-		if ((cp0flags & MIPS_CP0FL_CONFIGn(6)) != 0)
-			MIPS64_SHOW32(16, 6, "config6");
-		if ((cp0flags & MIPS_CP0FL_CONFIGn(7)) != 0)
-			MIPS64_SHOW32(16, 7, "config7");
+		if ((cp0flags & MIPS_CP0FL_CONFIG1) != 0)
+			SHOW32SEL(16, 1, "config1");
+		if ((cp0flags & MIPS_CP0FL_CONFIG2) != 0)
+			SHOW32SEL(16, 2, "config2");
+		if ((cp0flags & MIPS_CP0FL_CONFIG3) != 0)
+			SHOW32SEL(16, 3, "config3");
+		if ((cp0flags & MIPS_CP0FL_CONFIG4) != 0)
+			SHOW32SEL(16, 4, "config4");
+		if ((cp0flags & MIPS_CP0FL_CONFIG5) != 0)
+			SHOW32SEL(16, 5, "config5");
+		if ((cp0flags & MIPS_CP0FL_CONFIG6) != 0)
+			SHOW32SEL(16, 6, "config6");
+		if ((cp0flags & MIPS_CP0FL_CONFIG7) != 0)
+			SHOW32SEL(16, 7, "config7");
+		if ((cp0flags & MIPS_CP0FL_HWRENA) != 0)
+			SHOW32(7, "hwrena");
+		if ((cp0flags & MIPS_CP0FL_USERLOCAL) != 0)
+			SHOW32SEL(4, 2, "userlocal");
 	} else {
 		SHOW32(MIPS_COP_0_CONFIG, "config");
-#if defined(MIPS32) || defined(MIPS64)
+#if (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
 		if (CPUISMIPSNN) {
 			uint32_t val;
@@ -457,47 +460,194 @@
 	if (MIPS_HAS_LLSC) {
 		if (MIPS_HAS_LLADDR) {
-			if (CPUIS64BITS) {
+			if (CPUIS64BITS)
 				SHOW64(MIPS_COP_0_LLADDR, "lladdr");
-				SHOW64(MIPS_COP_0_WATCH_LO, "watchlo");
-			} else {
+			else
 				SHOW32(MIPS_COP_0_LLADDR, "lladdr");
-				SHOW32(MIPS_COP_0_WATCH_LO, "watchlo");
-			}
-		}
-
-		SHOW32(MIPS_COP_0_WATCH_HI, "watchhi");
-
+		}
+	}
+
+#if (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	for (int i=0; i < curcpu()->ci_cpuwatch_count; i++) {
+		const intptr_t lo = mipsNN_cp0_watchlo_read(i);
+		const uint32_t hi = mipsNN_cp0_watchhi_read(i);
+		printf("  %s%d:%*s %#" PRIxPTR "\t",
+		    "watchlo", i, FLDWIDTH - 8, "", lo);
+		printf("  %s%d:%*s %#" PRIx32 "\n",
+		    "watchhi", i, FLDWIDTH - 8, "", hi);
+	}
+#endif
+
+	if (CPUIS64BITS) {
+		SHOW64(MIPS_COP_0_TLB_XCONTEXT, "xcontext");
+	}
+
+	if (CPUISMIPSNN) {
 		if (CPUIS64BITS) {
-			SHOW64(MIPS_COP_0_TLB_XCONTEXT, "xcontext");
-		}
-
-		if (CPUISMIPSNN) {
-			if (CPUISMIPS64) {
-				SHOW64(MIPS_COP_0_PERFCNT, "perfcnt");
-			} else {
-				SHOW32(MIPS_COP_0_PERFCNT, "perfcnt");
-			}
-		}
-
-		if (((cp0flags & MIPS_CP0FL_USE) == 0) ||
-		    ((cp0flags & MIPS_CP0FL_ECC) != 0))
-			SHOW32(MIPS_COP_0_ECC, "ecc");
-
-		if (((cp0flags & MIPS_CP0FL_USE) == 0) ||
-		    ((cp0flags & MIPS_CP0FL_CACHE_ERR) != 0))
-			SHOW32(MIPS_COP_0_CACHE_ERR, "cacherr");
-
-		SHOW32(MIPS_COP_0_TAG_LO, "cachelo");
-		SHOW32(MIPS_COP_0_TAG_HI, "cachehi");
-
-		if (CPUIS64BITS) {
-			SHOW64(MIPS_COP_0_ERROR_PC, "errorpc");
+			SHOW64(MIPS_COP_0_PERFCNT, "perfcnt");
 		} else {
-			SHOW32(MIPS_COP_0_ERROR_PC, "errorpc");
-		}
-	}
-}
-
-#ifdef MIPS64_XLS
+			SHOW32(MIPS_COP_0_PERFCNT, "perfcnt");
+		}
+	}
+
+	if (((cp0flags & MIPS_CP0FL_USE) == 0) ||
+	    ((cp0flags & MIPS_CP0FL_ECC) != 0))
+		SHOW32(MIPS_COP_0_ECC, "ecc");
+
+	if (((cp0flags & MIPS_CP0FL_USE) == 0) ||
+	    ((cp0flags & MIPS_CP0FL_CACHE_ERR) != 0))
+		SHOW32(MIPS_COP_0_CACHE_ERR, "cacherr");
+
+	SHOW32(MIPS_COP_0_TAG_LO, "cachelo");
+	SHOW32(MIPS_COP_0_TAG_HI, "cachehi");
+
+	if (CPUIS64BITS) {
+		SHOW64(MIPS_COP_0_ERROR_PC, "errorpc");
+	} else {
+		SHOW32(MIPS_COP_0_ERROR_PC, "errorpc");
+	}
+}
+
+#if (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+static void
+db_watch_cmd(db_expr_t address, bool have_addr, db_expr_t count,
+		 const char *modif)
+{
+	struct cpu_info * const ci = curcpu();
+	cpu_watchpoint_t *cwp;
+	register_t mask=0;
+	uint32_t asid;
+	uint32_t mode;
+	db_expr_t value;
+	char str[6];
+
+	if (!have_addr) {
+		db_printf("%-3s %-5s %-16s %4s %4s\n",
+			"#", "MODE", "ADDR", "MASK", "ASID");
+		for (u_int i=0; i < ci->ci_cpuwatch_count; i++) {
+			cwp = &ci->ci_cpuwatch_tab[i];
+			mode = cwp->cw_mode;
+			if ((mode & CPUWATCH_RWX) == 0)
+				continue;	/* empty/disabled/invalid */
+			str[0] = (mode & CPUWATCH_READ)  ?  'r' : '-';
+			str[1] = (mode & CPUWATCH_WRITE) ?  'w' : '-';
+			str[2] = (mode & CPUWATCH_EXEC)  ?  'x' : '-';
+			str[3] = (mode & CPUWATCH_MASK)  ?  'm' : '-';
+			str[4] = (mode & CPUWATCH_ASID)  ?  'a' : 'g';
+			str[5] = '\0';
+			db_printf("%2u: %s %16" PRIxREGISTER
+			    " %4" PRIxREGISTER " %4x\n",
+			    i, str, cwp->cw_addr, cwp->cw_mask, cwp->cw_asid);
+		}
+		db_flush_lex();
+		return;
+	}
+
+	cwp = cpuwatch_alloc();
+	if (cwp == NULL) {
+		db_printf("no watchpoint available\n");
+		db_flush_lex();
+		return;
+	}
+
+	/*
+	 * parse modif to define mode
+	 */
+	KASSERT(modif != NULL);
+	mode = 0;
+	for (int i=0; modif[i] != '\0'; i++) {
+		switch(modif[i]) {
+		case 'w':
+			mode |= CPUWATCH_WRITE;
+			break;
+		case 'm':
+			mode |= CPUWATCH_MASK;
+			break;
+		case 'r':
+			mode |= CPUWATCH_READ;
+			break;
+		case 'x':
+			mode |= CPUWATCH_EXEC;
+			break;
+		case 'a':
+			mode |= CPUWATCH_ASID;
+			break;
+		}
+	}
+	if (mode == 0) {
+		db_printf("mode modifier(s) missing\n");
+		db_flush_lex();
+		return;
+	}
+
+	/*
+	 * if mask mode is requested get the mask,
+	 */
+	if (mode & CPUWATCH_MASK) {
+		if (! db_expression(&value)) {
+			db_printf("mask missing\n");
+			db_flush_lex();
+			return;
+		}
+		mask = (register_t)(value & __BITS(11, 3));
+	}
+
+	/*
+	 * if asid mode is requested, get the asid;
+	 * otherwise use global mode (and set asid=0)
+	 */
+	if (mode & CPUWATCH_ASID) {
+		if (! db_expression(&value)) {
+			db_printf("asid missing\n");
+			db_flush_lex();
+			return;
+		}
+		asid = (uint32_t)(value & __BITS(7,0));
+	} else {
+		asid = 0;
+	}
+
+	if (mode & (CPUWATCH_MASK|CPUWATCH_ASID))
+		db_skip_to_eol();
+	else
+		db_flush_lex();
+
+	/*
+	 * store to the (volatile) table entry
+	 * other CPUs can see this and load when resuming from pause
+	 */
+	cwp->cw_addr = (register_t)address;
+	cwp->cw_mask = (register_t)mask;
+	cwp->cw_asid = asid;
+	cwp->cw_mode = mode;
+
+	/*
+	 * program the CPU watchpoint regs
+	 */
+	cpuwatch_set(cwp);
+}
+
+static void
+db_unwatch_cmd(db_expr_t address, bool have_addr, db_expr_t count,
+		 const char *modif)
+{
+	struct cpu_info * const ci = curcpu();
+	const bool unwatch_all = !have_addr;
+	int n;
+
+	n = 0;
+	for (u_int i=0; i < ci->ci_cpuwatch_count; i++) {
+		cpu_watchpoint_t * const cwp = &ci->ci_cpuwatch_tab[i];
+		if (unwatch_all || (cwp->cw_addr == (register_t)address)) {
+			cpuwatch_free(cwp);
+			n++;
+		}
+	}
+	if (n == 0)
+		db_printf("no watch found on address %#" PRIxREGISTER "\n",
+		    (register_t)address);
+}
+#endif	/* (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0 */
+
+#if (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
 void
 db_mfcr_cmd(db_expr_t addr, bool have_addr, db_expr_t count,
@@ -519,5 +669,5 @@
 	__asm volatile(							\
 		".set push 			\n\t"			\
-		".set mips64			\n\t"			\
+		".set arch=xlr			\n\t"			\
 		".set noat			\n\t"			\
 		"mfcr %0,%1			\n\t"			\
@@ -539,5 +689,5 @@
 	}
 
-	if ((!have_addr) || (db_expression(&value) == 0)) {
+	if ((!have_addr) || (! db_expression(&value))) {
 		db_printf("Address missing\n");
 		db_flush_lex();
@@ -549,7 +699,7 @@
 	__asm volatile(							\
 		".set push 			\n\t"			\
-		".set mips64			\n\t"			\
+		".set arch=xlr			\n\t"			\
 		".set noat			\n\t"			\
-		"mfcr %0,%1			\n\t"			\
+		"mtcr %0,%1			\n\t"			\
 		".set pop 			\n\t"			\
 	    :: "r"(value), "r"(addr));
@@ -557,10 +707,22 @@
 	db_printf("control reg 0x%lx = 0x%lx\n", addr, value);
 }
-#endif /* MIPS64_XLS */
+#endif /* (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0 */
 
 const struct db_command db_machine_command_table[] = {
-	{ DDB_ADD_CMD("cp0",	db_cp0dump_cmd,		0,
+#ifdef MULTIPROCESSOR
+	{ DDB_ADD_CMD("cpu",	db_mach_cpu,		0,
+	  "switch to another cpu", "cpu#", NULL) },
+#endif
+	{ DDB_ADD_CMD("cp0",	db_cp0dump_cmd,	0,
 		"Dump CP0 registers.",
 		NULL, NULL) },
+#if (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	{ DDB_ADD_CMD("watch",	db_watch_cmd,		CS_MORE,
+		"set cp0 watchpoint",
+		"address <mask> <asid> </rwxma>", NULL) },
+	{ DDB_ADD_CMD("unwatch",db_unwatch_cmd,		0,
+		"delete cp0 watchpoint",
+		"address", NULL) },
+#endif	/* (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0 */
 	{ DDB_ADD_CMD("kvtop",	db_kvtophys_cmd,	0,
 		"Print the physical address for a given kernel virtual address",
@@ -570,5 +732,5 @@
 		"Print out TLB entries. (only works with options DEBUG)",
 		NULL, NULL) },
-#ifdef MIPS64_XLS
+#if (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
 	{ DDB_ADD_CMD("mfcr", 	db_mfcr_cmd,		CS_NOREPEAT,
 		"Dump processor control register",
@@ -683,26 +845,16 @@
 inst_load(int inst)
 {
-	InstFmt i;
-
-	i.word = inst;
-
-	switch (i.JType.op) {
-	case OP_LWC1:
-	case OP_LB:
-	case OP_LH:
-	case OP_LW:
-	case OP_LD:
-	case OP_LBU:
-	case OP_LHU:
-	case OP_LWU:
-	case OP_LDL:
-	case OP_LDR:
-	case OP_LWL:
-	case OP_LWR:
-	case OP_LL:
-		return 1;
-	default:
-		return 0;
-	}
+	InstFmt i = { .word = inst, };
+
+	/*
+	 * All loads are opcodes 04x or 06x.
+	 */
+	if ((i.JType.op & 050) != 040)
+		return false;
+
+	/*
+	 * Except these this opcode is not a load.
+	 */
+	return i.JType.op != OP_PREF;
 }
 
@@ -710,37 +862,30 @@
 inst_store(int inst)
 {
-	InstFmt i;
-
-	i.word = inst;
-
-	switch (i.JType.op) {
-	case OP_SWC1:
-	case OP_SB:
-	case OP_SH:
-	case OP_SW:
-	case OP_SD:
-	case OP_SDL:
-	case OP_SDR:
-	case OP_SWL:
-	case OP_SWR:
-	case OP_SCD:
-		return 1;
-	default:
-		return 0;
-	}
+	InstFmt i = { .word = inst, };
+
+	/*
+	 * All stores are opcodes 05x or 07x.
+	 */
+	if ((i.JType.op & 050) != 050)
+		return false;
+
+	/*
+	 * Except these two opcodes are not stores.
+	 */
+	return i.JType.op != OP_RSVD073 && i.JType.op != OP_CACHE;
 }
 
 /*
  * Return the next pc if the given branch is taken.
- * MachEmulateBranch() runs analysis for branch delay slot.
+ * mips_emul_branch() runs analysis for branch delay slot.
  */
 db_addr_t
 branch_taken(int inst, db_addr_t pc, db_regs_t *regs)
 {
+	struct pcb * const pcb = lwp_getpcb(curlwp);
+	const uint32_t fpucsr = PCB_FSR(pcb);
 	vaddr_t ra;
-	unsigned fpucsr;
-
-	fpucsr = PCB_FSR(&curlwp->l_addr->u_pcb);
-	ra = MachEmulateBranch((struct trapframe *)regs, pc, fpucsr, 0);
+
+	ra = mips_emul_branch((struct trapframe *)regs, pc, fpucsr, false);
 	return ra;
 }
@@ -758,5 +903,5 @@
 	
 	if (pc < MIPS_KSEG0_START)
-		ins = fuiword((void *)pc);
+		ins = ufetch_uint32((void *)pc);
 	else
 		ins = *(unsigned *)pc;
@@ -767,2 +912,54 @@
 	return (pc);
 }
+
+#ifdef MULTIPROCESSOR
+
+bool 
+ddb_running_on_this_cpu_p(void)
+{               
+	return ddb_cpu == cpu_number();
+}
+
+bool 
+ddb_running_on_any_cpu_p(void)
+{               
+	return ddb_cpu != NOCPU;
+}
+
+void
+db_resume_others(void)
+{
+	u_int cpu_me = cpu_number();
+
+	if (atomic_cas_uint(&ddb_cpu, cpu_me, NOCPU) == cpu_me)
+		cpu_resume_others();
+}
+
+static void
+db_mach_cpu(db_expr_t addr, bool have_addr, db_expr_t count, const char *modif)
+{
+	CPU_INFO_ITERATOR cii;
+	struct cpu_info *ci;
+	
+	if (!have_addr) {
+		cpu_debug_dump();
+		return;
+	}
+	for (CPU_INFO_FOREACH(cii, ci)) {
+		if (cpu_index(ci) == addr)
+			break;
+	}
+	if (ci == NULL) {
+		db_printf("CPU %ld not configured\n", (long)addr);
+		return;
+	}
+	if (ci != curcpu()) {
+		if (!cpu_is_paused(cpu_index(ci))) {
+			db_printf("CPU %ld not paused\n", (long)addr);
+			return;
+		}
+		(void)atomic_cas_uint(&ddb_cpu, cpu_number(), cpu_index(ci));
+		db_continue_cmd(0, false, 0, "");
+	}
+}
+#endif	/* MULTIPROCESSOR */
Index: /trunk/src/sys/arch/mips/mips/db_trace.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/db_trace.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/db_trace.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: db_trace.c,v 1.35.38.4 2010/02/01 04:16:19 matt Exp $	*/
+/*	$NetBSD: db_trace.c,v 1.35.38.5 2011/04/29 08:26:25 matt Exp $	*/
 
 /*
@@ -28,5 +28,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: db_trace.c,v 1.35.38.4 2010/02/01 04:16:19 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: db_trace.c,v 1.35.38.5 2011/04/29 08:26:25 matt Exp $");
 
 #include "opt_ddb.h"
@@ -36,5 +36,4 @@
 #include <sys/systm.h>
 #include <sys/proc.h>
-#include <sys/user.h>
 #include <sys/cpu.h>
 
@@ -145,24 +144,9 @@
 	struct proc *p;
 	struct lwp *l;
-	bool trace_thread = false;
-	bool lwpaddr = false;
 	const char *cp = modif;
 	char c;
-
-	while ((c = *cp++) != 0) {
-		if (c == 'a') {
-			lwpaddr = true;
-			trace_thread = true;
-		}
-		if (c == 't')
-			trace_thread = true;
-#if 0
-		if (c == 'u')
-			/* todo */
-#endif
-	}
-
-
-	if (!have_addr || !trace_thread) {
+	bool lwpaddr = false;
+
+	if (!have_addr) {
 		struct reg * regs = &ddb_regs;
 		stacktrace_subr(regs->r_regs[_R_A0],
@@ -179,11 +163,16 @@
 	}
 
+	while ((c = *cp++) != 0) {
+		if (c == 'a') {
+			lwpaddr = true;
+		}
+	}
+
 	if (lwpaddr) {
-		/* trace/a */
 		l = (struct lwp *)addr;
-		p = l->l_proc;
-		(*pr)("trace: pid %d ", p->p_pid);
+		(*pr)("pid %d.%d ", l->l_proc->p_pid, l->l_lid);
 	} else {
 		/* "trace/t" */
+
 		(*pr)("pid %d ", (int)addr);
 		p = p_find(addr, PFIND_LOCKED);
@@ -193,13 +182,11 @@
 		}	
 		l = LIST_FIRST(&p->p_lwps); /* XXX NJWLWP */
-		KASSERT(l != NULL);
-	}
-	(*pr)("lid %d ", l->l_lid);
-	if (!(l->l_flag & LW_INMEM)) {
-		(*pr)("swapped out\n");
-		return;
-	}
-
-	pcb = &(l->l_addr->u_pcb);
+		if (!(l->l_flag & LW_INMEM)) {
+			(*pr)("swapped out\n");
+			return;
+		}
+	}
+
+	pcb = lwp_getpcb(l);
 	(*pr)("at %p\n", pcb);
 
